diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRenderer.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRenderer.java
index b0922931b..c01ecfd26 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRenderer.java
@@ -8,6 +8,8 @@ import net.minecraft.client.render.renderer.State;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.EntityDispatcher;
 import net.minecraft.core.util.collection.NamespaceID;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.joml.Math;
 import org.joml.primitives.AABBdc;
@@ -36,7 +38,7 @@ public abstract class EntityRenderer<T extends Entity> {
     protected EntityRendererDispatcher renderDispatcher = null;
     protected Class<? extends T> appliedClass = null;
 
-    private float shadowSize;
+    private final float shadowSize;
     protected float shadowOpacity;
 
     public EntityRenderer(final float shadowSize) {
@@ -80,12 +82,19 @@ public abstract class EntityRenderer<T extends Entity> {
         } else {
             model = EntityGeometryMojangData.Cache.getFallbackModel();
         }
-        this.modelMap.put(localId, model);
+        var last = this.modelMap.put(localId, model);
+        if (last != null && last != model) {
+            last.delete();
+        }
         return model;
     }
 
     public final @NotNull EntityRenderer<T> setModel(@NotNull final String localId, @NotNull final String modelId, final double inflation) {
-        this.modelMap.put(localId, EntityGeometryMojangData.Cache.getModel(modelId, inflation));
+        var model = EntityGeometryMojangData.Cache.getModel(modelId, inflation);
+        var last = this.modelMap.put(localId, model);
+        if (last != null && last != model) {
+            last.delete();
+        }
         return this;
     }
 
@@ -138,7 +147,8 @@ public abstract class EntityRenderer<T extends Entity> {
         GLRenderer.globalSetLightEnabled(true);
     }
 
-    private void renderShadow(final @NotNull TessellatorGeneral tessellator, @NotNull final T entity, final double posX, final double posY, final double posZ,
+    private void renderShadow(final @NotNull TessellatorGeneral tessellator, @NotNull final T entity,
+                              final double posX, final double posY, final double posZ,
                               final float opacity, final float partialTick) {
         GLRenderer.enableState(State.BLEND);
         GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
@@ -163,12 +173,16 @@ public abstract class EntityRenderer<T extends Entity> {
         final double dzLerp = posZ - lerpZ;
         tessellator.startDrawingQuads();
 
-        for (int blockX = minX; blockX <= maxX; blockX++) {
-            for (int blockY = minY; blockY <= maxY; blockY++) {
-                for (int blockZ = minZ; blockZ <= maxZ; blockZ++) {
-                    final int blockId = world.getBlockId(blockX, blockY - 1, blockZ);
-                    if (blockId > 0 && world.getBlockLightValue(blockX, blockY, blockZ) > 3) {
-                        renderShadowOnBlock(tessellator, entity, Blocks.blocksList[blockId], posX, posY + (double) entity.getShadowHeightOffs(), posZ, blockX, blockY, blockZ, opacity, shadowSize, dxLerp, dyLerp + (double) entity.getShadowHeightOffs(), dzLerp);
+        TilePos q = new TilePos();
+        TilePos blockPos = new TilePos();
+        for (blockPos.x = minX; blockPos.x <= maxX; blockPos.x++) {
+            for (blockPos.y = minY; blockPos.y <= maxY; blockPos.y++) {
+                for (blockPos.z = minZ; blockPos.z <= maxZ; blockPos.z++) {
+                    final @NotNull Block<?> block = world.getBlockType(blockPos.down(q));
+                    if (world.getBlockLightValue(blockPos) > 3) {
+                        renderShadowOnBlock(tessellator, entity, block,
+                            posX, posY + (double) entity.getShadowHeightOffs(), posZ,
+                            blockPos, opacity, shadowSize, dxLerp, dyLerp + (double) entity.getShadowHeightOffs(), dzLerp);
                     }
                 }
 
@@ -181,15 +195,16 @@ public abstract class EntityRenderer<T extends Entity> {
         GLRenderer.setDepthMask(true);
     }
 
-    private void renderShadowOnBlock(final @NotNull TessellatorGeneral tessellator, final @NotNull T entity, final @NotNull Block<?> block, final double d, final double d1, final double d2,
-                                     final int x, final int y, final int z, final float opacity, final float size, final double xo,
+    private void renderShadowOnBlock(final @NotNull TessellatorGeneral tessellator, final @NotNull T entity, final @NotNull Block<?> block,
+                                     final double x, final double y, final double z,
+                                     final @NotNull TilePosc tilePos, final float opacity, final float size, final double xo,
                                      final double yo, final double zo) {
         if (!block.isCubeShaped()) {
             return;
         }
-        double brightness = entity.world.getLightBrightness(x, y, z);
+        double brightness = entity.world.getLightBrightness(tilePos);
         if (Global.accessor.isFullbrightEnabled()) brightness = 1.0f;
-        double alpha = ((double) opacity - (d1 - ((double) (y + 1) + yo)) / 2D) * 0.5D * brightness;
+        double alpha = ((double) opacity - (y - ((double) (tilePos.y() + 1) + yo)) / 2D) * 0.5D * brightness;
         if (alpha < 0.0D) {
             return;
         }
@@ -197,7 +212,7 @@ public abstract class EntityRenderer<T extends Entity> {
             alpha = 1.0D;
         }
         tessellator.setColor4f(1.0F, 1.0F, 1.0F, (float) alpha);
-        final AABBdc aabb = block.getCollisionBoundingBoxFromPool(entity.world, x, y, z);
+        final AABBdc aabb = block.getCollisionAABB(entity.world, tilePos);
         if (aabb == null) {
             return;
         }
@@ -206,10 +221,10 @@ public abstract class EntityRenderer<T extends Entity> {
         final double yMin = aabb.maxY() + yo + 0.015625D - 1;
         final double zMin = aabb.minZ() + zo;
         final double zMax = aabb.maxZ() + zo;
-        final float f2 = (float) ((d - xMin) / 2D / (double) size + 0.5D);
-        final float f3 = (float) ((d - xMax) / 2D / (double) size + 0.5D);
-        final float f4 = (float) ((d2 - zMin) / 2D / (double) size + 0.5D);
-        final float f5 = (float) ((d2 - zMax) / 2D / (double) size + 0.5D);
+        final float f2 = (float) ((x - xMin) / 2D / (double) size + 0.5D);
+        final float f3 = (float) ((x - xMax) / 2D / (double) size + 0.5D);
+        final float f4 = (float) ((z - zMin) / 2D / (double) size + 0.5D);
+        final float f5 = (float) ((z - zMax) / 2D / (double) size + 0.5D);
         tessellator.addVertexWithUV(xMin, yMin, zMin, f2, f4);
         tessellator.addVertexWithUV(xMin, yMin, zMax, f2, f5);
         tessellator.addVertexWithUV(xMax, yMin, zMax, f3, f5);
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRenderer.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRenderer.java
index 448fec596..e79f8b6cc 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRenderer.java
@@ -59,10 +59,12 @@ public abstract class MobRenderer<T extends Mob> extends EntityRenderer<T> {
         }
         renderAdditional(tessellator, entity, partialTick);
 
-        final int argb = getOverlayColor(entity, 1f, partialTick);
+        final int argb = getOverlayColor(entity, partialTick);
         final boolean hasOverlayAlpha = Color.alphaFromInt(argb) > 0;
         if (hasOverlayAlpha || entity.hurtTime > 0 || entity.deathTime > 0) {
+            this.renderDispatcher.textureManager.loadTexture("/assets/minecraft/textures/misc/white.png").bind();
             GLRenderer.pushFrame();
+            GLRenderer.setLightmapCoord2i(15, 15);
             GLRenderer.setShader(Shaders.COLOR_WORLD);
             GLRenderer.enableState(State.BLEND);
             GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
@@ -78,14 +80,10 @@ public abstract class MobRenderer<T extends Mob> extends EntityRenderer<T> {
 
             }
             if (hasOverlayAlpha) {
-                final float r = Color.redFromInt(argb) / 255f;
-                final float g = Color.greenFromInt(argb) / 255f;
-                final float b = Color.blueFromInt(argb) / 255f;
-                final float a = Color.alphaFromInt(argb) / 255f;
-                for (int layer = 0; layer < maxRenderLayer; layer++) {
+                for (int layer = 0; layer <= maxRenderLayer; layer++) {
                     final StaticEntityModel model = this.setupModels.get(layer);
                     if (model != null) {
-                        GLRenderer.setColor4f(r, g, b, a);
+                        GLRenderer.setColor1i(argb);
                         model.render();
                     }
                 }
@@ -170,7 +168,7 @@ public abstract class MobRenderer<T extends Mob> extends EntityRenderer<T> {
     }
 
     protected void renderLivingLabel(final @NotNull TessellatorGeneral t, final @NotNull T entity, final @NotNull CharSequence text, final double x, final double y, final double z, final int maxDistance, final boolean depthTest) {
-        final float cameraDistance = (float) this.renderDispatcher.camera.distanceTo(entity);
+        final float cameraDistance = (float) Minecraft.getMinecraft().activeCamera.distanceTo(entity);
         if (cameraDistance > maxDistance) {
             return;
         }
@@ -209,7 +207,7 @@ public abstract class MobRenderer<T extends Mob> extends EntityRenderer<T> {
         GLRenderer.popFrame();
     }
 
-    protected int getOverlayColor(final @NotNull T entity, final float brightness, final float partialTick) {
+    protected int getOverlayColor(final @NotNull T entity, final float partialTick) {
         return 0;
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererCreeper.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererCreeper.java
index ed5a936cf..d13a5aa59 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererCreeper.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererCreeper.java
@@ -18,7 +18,7 @@ public class MobRendererCreeper extends MobRenderer<MobCreeper> {
     }
 
     @Override
-    protected int getOverlayColor(final @NotNull MobCreeper creeper, final float brightness, final float partialTick) {
+    protected int getOverlayColor(final @NotNull MobCreeper creeper, final float partialTick) {
         final float step = creeper.getSwelling(partialTick);
         if ((int) (step * 10.0f) % 2 == 0) {
             return 0;
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java
index 96912b50d..4848aefe5 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java
@@ -109,17 +109,18 @@ public class MobRendererPlayer extends MobRendererBipedArmored<Player> {
 
     @Override
     protected void renderSpecials(final @NotNull TessellatorGeneral t, final @NotNull Player entity, final double x, final double y, final double z) {
-        if (Minecraft.getMinecraft().thePlayer.getGamemode() != Gamemodes.SPECTATOR && entity.getGamemode() == Gamemodes.SPECTATOR) {
+        Minecraft mc = Minecraft.getMinecraft();
+        if (mc.thePlayer.getGamemode() != Gamemodes.SPECTATOR && entity.getGamemode() == Gamemodes.SPECTATOR) {
             return;
         }
-        if (Minecraft.getMinecraft().gameSettings.immersiveMode.drawNames() && this.renderDispatcher.camera != null) // Render name
+        if (mc.gameSettings.immersiveMode.drawNames() && mc.activeCamera != null) // Render name
         {
-            if (this.renderDispatcher.camera instanceof EntityCamera && ((EntityCamera) this.renderDispatcher.camera).mob == entity) {
+            if (mc.activeCamera instanceof EntityCamera entityCamera && entityCamera.mob == entity) {
                 return;
             }
             final float f = 1.6F;
             final float f1 = 0.01666667F * f;
-            final float f2 = (float) this.renderDispatcher.camera.distanceTo(entity); //getting lost on renderManager.livingPlayer
+            final float f2 = (float) mc.activeCamera.distanceTo(entity); //getting lost on renderManager.livingPlayer
             final float f3 = entity.isSneaking() ? 32F : 64F;
             if (f2 < f3) {
                 final String s = entity.getDisplayName();
diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModel.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModel.java
index f0f09125d..7f99fffff 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModel.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModel.java
@@ -8,6 +8,7 @@ import net.minecraft.client.render.font.FontRenderer;
 import net.minecraft.client.render.renderer.BlendFactor;
 import net.minecraft.client.render.renderer.FrontFace;
 import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.Shaders;
 import net.minecraft.client.render.renderer.State;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.TessellatorGeneral;
@@ -32,6 +33,7 @@ public abstract class ItemModel {
 
     public void renderGui(@NotNull TessellatorGeneral tessellator, @Nullable Entity holder, @NotNull ItemStack itemStack, int x, int y, int lightmapCoord, float partialTick) {
         GLRenderer.pushFrame();
+        GLRenderer.setShader(Shaders.TERRAIN);
         GLRenderer.globalSetLightEnabled(false);
         GLRenderer.enableState(State.BLEND);
         GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
@@ -56,6 +58,7 @@ public abstract class ItemModel {
 
     public void renderFirstPerson(@NotNull TessellatorGeneral tessellator, @NotNull ItemRenderer itemRenderer, @NotNull Player player, @NotNull ItemStack itemStack, int lightmapCoord, float partialTick) {
         GLRenderer.pushFrame();
+        GLRenderer.setShader(Shaders.TERRAIN);
         GLRenderer.enableState(State.BLEND);
         GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
         GLRenderer.enableState(State.CULL_FACE);
diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBlock.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBlock.java
index 98ee01810..92297b7da 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBlock.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBlock.java
@@ -18,6 +18,7 @@ import net.minecraft.core.item.block.ItemBlock;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.joml.Math;
+import org.lwjgl.opengl.GL41;
 import org.useless.dragonfly.DisplayPos;
 
 public class ItemModelBlock extends ItemModelStandard {
@@ -48,6 +49,7 @@ public class ItemModelBlock extends ItemModelStandard {
             return;
         }
         random.setSeed(187L);
+        GLRenderer.setShader(Shaders.TERRAIN);
         DisplayPos displayPos = getDisplayPos(displayPosId);
         GLRenderer.modelM4f().translate(displayPos.tx, displayPos.ty, displayPos.tz);
         GLRenderer.modelM4f().rotateX(Math.toRadians(displayPos.rx));
@@ -86,7 +88,7 @@ public class ItemModelBlock extends ItemModelStandard {
             return;
         }
         GLRenderer.pushFrame();
-        GLRenderer.setShader(Shaders.WORLD);
+        GLRenderer.setShader(Shaders.TERRAIN);
         GLRenderer.enableState(State.BLEND);
         GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
         GLRenderer.enableState(State.CULL_FACE);
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/Particle.java b/game/client/src/main/java/net/minecraft/client/render/particle/Particle.java
index b7e7fb6a4..9a03a9a07 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/Particle.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/Particle.java
@@ -218,7 +218,7 @@ public class Particle {
 
         Direction direction = Direction.NONE;
         while (dx * dx + dy * dy + dz * dz < length * length + 4) {
-            Block<?> block = this.world.getBlock(tilePos);
+            Block<?> block = this.world.getBlockType(tilePos);
             if (block != null && collidesWithBlock(block, this.world.getBlockData(tilePos))) {
                 this.aabbs.clear();
                 block.getCollisionAABBs(this.world, tilePos, this.refAABB.setMin(tilePos.x, tilePos.y, tilePos.z).setMax(tilePos.x + 1, tilePos.y + 1, tilePos.z + 1), this.aabbs);
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleLeaf.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleLeaf.java
index 5f8b6b132..0a8577142 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleLeaf.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleLeaf.java
@@ -1,12 +1,10 @@
 package net.minecraft.client.render.particle;
 
-import net.minecraft.client.render.ParticleEngine;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
 import net.minecraft.client.render.tessellator.TessellatorParticle;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicLeavesBase;
-import net.minecraft.core.block.Blocks;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
@@ -30,7 +28,7 @@ public class ParticleLeaf extends Particle {
     }
 
     public ParticleLeaf init(@NotNull TilePos tilePos) {
-        Block<?> block = Blocks.blocksList[this.world.getBlockId(tilePos)];
+        Block<?> block = this.world.getBlockType(tilePos);
         if (!Block.hasLogicClass(block, BlockLogicLeavesBase.class)) this.remove();
         int col = BlockColorDispatcher.getInstance().getDispatch(block).getWorldColor(this.world, tilePos.x, tilePos.y, tilePos.z, 0);
         this.rCol *= (float) (col >> 16 & 0xff) / 255F;
diff --git a/game/client/src/main/java/net/minecraft/client/render/renderer/GLRenderer.java b/game/client/src/main/java/net/minecraft/client/render/renderer/GLRenderer.java
index 5b0a84583..f60caeff7 100644
--- a/game/client/src/main/java/net/minecraft/client/render/renderer/GLRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/renderer/GLRenderer.java
@@ -116,6 +116,9 @@ public class GLRenderer {
     private float currentLightmapBlock = 15.5f/16f;
     private float currentLightmapSky = 15.5f/16f;
 
+    private final float[] alphaTestStack = new float[RENDER_FRAMES_STACK_SIZE];
+    private float currentAlphaTest = 0.1f;
+
     private int stackIndex = 0;
 
 
@@ -136,7 +139,7 @@ public class GLRenderer {
         shader.bind();
         if (instance.viewProjMatDirty) {
             GL41.glBindBuffer(GL41.GL_UNIFORM_BUFFER, UniformBlockManager.BLOCK_MATRICES.ubo);
-            UniformBlockManager.BLOCK_MATRICES.adapter.bufferData(projectionM4f(), N * 4 * 4 * 0, UniformBlockManager.BLOCK_MATRICES.buffer.clear());
+            UniformBlockManager.BLOCK_MATRICES.adapter.bufferData(projectionM4f(), N * 4 * 4 * 0, UniformBlockManager.BLOCK_MATRICES.buffer);
             UniformBlockManager.BLOCK_MATRICES.adapter.bufferData(projectionM4f().invert(matBuf), N * 4 * 4 * 1, UniformBlockManager.BLOCK_MATRICES.buffer);
             UniformBlockManager.BLOCK_MATRICES.adapter.bufferData(viewM4f(), N * 4 * 4 * 2, UniformBlockManager.BLOCK_MATRICES.buffer);
             UniformBlockManager.BLOCK_MATRICES.adapter.bufferData(viewM4f().invert(matBuf), N * 4 * 4 * 3, UniformBlockManager.BLOCK_MATRICES.buffer);
@@ -147,8 +150,10 @@ public class GLRenderer {
         shader.uniformMat4f("model", modelM4f());
         shader.uniformMat4f("texture", textureM4f());
 
+        shader.uniformFloat("uAlphaTest", instance.currentAlphaTest);
         shader.uniformVec4f("uColor", Color.redFromInt(instance.currentColor)/255f, Color.greenFromInt(instance.currentColor)/255f, Color.blueFromInt(instance.currentColor)/255f, Color.alphaFromInt(instance.currentColor)/255f);
         shader.uniformFloat("uCurrentTick", instance.mc.ticksRan + instance.mc.timer.partialTicks);
+        shader.uniformFloat("uPartialTick", instance.mc.timer.partialTicks);
         shader.uniformFloat("uLineWidth", instance.currentLineWidth);
 
         double renderScale = (float) instance.mc.gameSettings.renderScale.value.scale;
@@ -339,6 +344,14 @@ public class GLRenderer {
         return instance.currentLightmapSky;
     }
 
+    public static void setAlphaTest(float alphaTest) {
+        instance.currentAlphaTest = alphaTest;
+    }
+
+    public static float getAlphaTest() {
+        return instance.currentAlphaTest;
+    }
+
     public static void setColor1i(int argb) {
         instance.currentColor = argb;
     }
@@ -411,6 +424,7 @@ public class GLRenderer {
         instance.polygonUnitsStack[instance.stackIndex] = instance.currentPolygonUnits;
         instance.lightmapBlockStack[instance.stackIndex] = instance.currentLightmapBlock;
         instance.lightmapSkyStack[instance.stackIndex] = instance.currentLightmapSky;
+        instance.alphaTestStack[instance.stackIndex] = instance.currentAlphaTest;
 
         if (DEBUG) {
             StackTraceElement[] eles = Thread.currentThread().getStackTrace();
@@ -431,6 +445,7 @@ public class GLRenderer {
 
         instance.projectionMatrixStack.pushMatrix();
         instance.viewMatrixStack.pushMatrix();
+        instance.viewProjMatDirty = true;
         instance.modelMatrixStack.pushMatrix();
         instance.textureMatrixStack.pushMatrix();
     }
@@ -510,9 +525,11 @@ public class GLRenderer {
 
         instance.currentLightmapBlock = instance.lightmapBlockStack[instance.stackIndex];
         instance.currentLightmapSky = instance.lightmapSkyStack[instance.stackIndex];
+        instance.currentAlphaTest = instance.alphaTestStack[instance.stackIndex];
     }
 
     protected static void reset() {
         instance.stackIndex = 1;
+        setShader(Shaders.INTERFACE);
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/renderer/Shaders.java b/game/client/src/main/java/net/minecraft/client/render/renderer/Shaders.java
index e8aaee8eb..248d155e0 100644
--- a/game/client/src/main/java/net/minecraft/client/render/renderer/Shaders.java
+++ b/game/client/src/main/java/net/minecraft/client/render/renderer/Shaders.java
@@ -23,6 +23,8 @@ public final class Shaders {
     public static final @NotNull ShaderProvider PROVIDER_INTERNAL = new ShaderProviderInternal("/shaders/");
 
     public static final @NotNull Shader WORLD = register("world", new Shader());
+    public static final @NotNull Shader AURORA = register("aurora", new Shader());
+    public static final @NotNull Shader ENTITY = register("entity", new Shader());
     public static final @NotNull Shader TERRAIN = register("terrain", new Shader());
     public static final @NotNull Shader INTERFACE = register("interface", new Shader());
     public static final @NotNull Shader COLOR = register("color", new Shader());
diff --git a/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRendererMultiDraw.java b/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRendererMultiDraw.java
index 1af75351e..632d6311f 100644
--- a/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRendererMultiDraw.java
+++ b/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRendererMultiDraw.java
@@ -10,7 +10,7 @@ import net.minecraft.client.render.block.model.BlockModelDispatcher;
 import net.minecraft.client.render.culling.CameraFrustum;
 import net.minecraft.client.render.terrain.VertexBuffer.Entry;
 import net.minecraft.client.render.tessellator.TessellatorTerrainImpl;
-import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.Block;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.chunk.Chunk;
@@ -67,25 +67,21 @@ public class ChunkRendererMultiDraw extends ChunkRenderer {
             for (pos.y = minY; pos.y < maxY; pos.y++) {
                 for (pos.z = minZ; pos.z < maxZ; pos.z++) {
                     for (pos.x = minX; pos.x < maxX; pos.x++) {
-                        final int blockId = chunkCache.getBlockId(pos);
-                        if (blockId <= 0) {
-                            continue;
-                        }
+                        final @NotNull Block<?> block = chunkCache.getBlockType(pos);
                         if (!hasStartedDrawing) {
                             hasStartedDrawing = true;
                             tessellator.startDrawingQuads();
-//							tessellator.setTranslation(-this.posX, -this.posY, -this.posZ);
 
                             RenderRegion region = this.terrainRenderer.getRenderRegionAtBlockPos(this.posX, this.posZ);
                             tessellator.setTranslation(-(region.posX << this.terrainRenderer.REGION_SIZE), 0.0, -(region.posZ << this.terrainRenderer.REGION_SIZE));
                         }
-                        if (renderPass == 0 && Blocks.isEntityTile[blockId]) {
+                        if (renderPass == 0 && block.isEntityTile()) {
                             final TileEntity tileentity = chunkCache.getTileEntity(pos);
                             if (tileentity != null && TileEntityRenderDispatcher.instance.hasRenderer(tileentity)) {
                                 this.renderableBlockEntities.add(tileentity);
                             }
                         }
-                        final BlockModel<?> model = BlockModelDispatcher.getInstance().getDispatch(Blocks.blocksList[blockId]);
+                        final BlockModel<?> model = BlockModelDispatcher.getInstance().getDispatch(block);
                         final int blockRenderPass = model.renderLayer();
 
                         if (blockRenderPass != renderPass) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/tessellator/Tessellator.java b/game/client/src/main/java/net/minecraft/client/render/tessellator/Tessellator.java
index fb1d12f89..9710f6ee6 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tessellator/Tessellator.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tessellator/Tessellator.java
@@ -2,19 +2,39 @@ package net.minecraft.client.render.tessellator;
 
 import net.minecraft.client.render.renderer.DrawMode;
 import org.jetbrains.annotations.NotNull;
+import org.joml.Vector3dc;
+import org.joml.Vector3fc;
 
 public interface Tessellator {
     boolean QUAD_EMULATION = /*Minecraft.getOs() == EnumOS.macos || */true; // I hate you so fucking much apple
     void startDrawing(@NotNull DrawMode drawMode);
-    @Deprecated
     default void startDrawingQuads() {
         startDrawing(DrawMode.QUADS);
     }
 
     void addVertex(double x, double y, double z);
+    default void addVertex(@NotNull Vector3dc pos) {
+        addVertex(pos.x(), pos.y(), pos.z());
+    }
+    default void addVertex(@NotNull Vector3fc pos) {
+        addVertex(pos.x(), pos.y(), pos.z());
+    }
 
     void setTranslation(double x, double y, double z);
+    default void setTranslation(@NotNull Vector3dc pos) {
+        setTranslation(pos.x(), pos.y(), pos.z());
+    }
+    default void setTranslation(@NotNull Vector3fc pos) {
+        setTranslation(pos.x(), pos.y(), pos.z());
+    }
+
     void offsetTranslation(double x, double y, double z);
+    default void offsetTranslation(@NotNull Vector3dc pos) {
+        offsetTranslation(pos.x(), pos.y(), pos.z());
+    }
+    default void offsetTranslation(@NotNull Vector3fc pos) {
+        offsetTranslation(pos.x(), pos.y(), pos.z());
+    }
 
     default void drawRectangle(int x, int y, int width, int height) {
         this.addVertex(x, y, 0.0D);
